mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const scontisticaSchema = new Schema({
  idapp: {
    type: String,
  },
  attivo: {
    type: Boolean,
  },
  code: {
    type: String,
  },
  description: {
    type: String,
  },
  qta: {
    type: Number,
  },
  perc_sconto: {
    type: Number,
  },
  price: {
    type: Number,
  },
  applica: {
    type: Number,
  },
  comulativo: {
    type: Boolean,
    default: false,
  },
});

var Scontistica = module.exports = mongoose.model('Scontistica', scontisticaSchema);

module.exports.getFieldsForSearch = function () {
  return [
    { field: 'code', type: tools.FieldType.string },
    { field: 'description', type: tools.FieldType.string }
  ]
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp, attivo: true };

  return await Scontistica.find(myfind);
};

module.exports.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });

